pub struct SystemAllocator;

unsafe impl alloc::alloc::GlobalAlloc for SystemAllocator {
    unsafe fn alloc(&self, layout: core::alloc::Layout) -> *mut u8 {
        crate::sys_allocate(&layout)
    }
    unsafe fn dealloc(&self, ptr: *mut u8, layout: core::alloc::Layout) {
        crate::sys_deallocate(ptr, &layout);
    }
}

#[global_allocator]
static ALLOCATOR: SystemAllocator = SystemAllocator;

#[cfg(not(test))]
#[alloc_error_handler]
fn alloc_error_handler(layout: alloc::alloc::Layout) -> ! {
    panic!("allocation error: {:?}", layout)
}
